<template functional>
  <span
    :ref="data.ref"
    :class="[data.class, data.staticClass]"
    :style="[data.style, data.staticStyle]"
    v-bind="data.attrs"
    v-on="listeners"
  >
    <g-link
      v-if="$options.methods.internal(props.to)"
      :to="props.to"
      :aria-label="props.ariaLabel"
      class="reset"
    >
      <slot />
    </g-link>
    <a
      v-else-if="$options.methods.mailto(props.to)"
      :href="props.to"
      :aria-label="props.ariaLabel"
      class="mailtoui reset"
    >
      <slot />
    </a>
    <a
      v-else-if="$options.methods.tel(props.to)"
      :href="$options.methods.formatTel(props.to)"
      :aria-label="props.ariaLabel"
      class="reset"
    >
      <slot />
    </a>
    <a
      v-else
      :href="`${props.to}?ref=eudea.es`"
      :aria-label="props.ariaLabel"
      class="reset"
      rel="nofollow noopener"
      target="_blank"
    >
      <slot />
    </a>
  </span>
</template>

<script>
export default {
  name: 'HyperLink',
  props: {
    to: { type: String, required: true },
    ariaLabel: { type: String, default: undefined },
  },
  methods: {
    internal(link) {
      const isInternal = /^\/([a-z0-9-]+\/)*$/;
      return isInternal.test(link);
    },
    mailto(link) {
      const isMailTo = /^mailto:/;
      return isMailTo.test(link);
    },
    tel(link) {
      const isTel = /^tel:/;
      return isTel.test(link);
    },
    formatTel(tel) {
      return tel.replace(/[\s()-]/g, '');
    },
  },
};
</script>
